Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 84)
@@ -1,20 +1,22 @@
 package com.framsticks.gui;
 
-import com.framsticks.core.Node;
+import com.framsticks.core.Instance;
 import com.framsticks.core.Path;
 import com.framsticks.gui.view.*;
 import com.framsticks.gui.view.TreeCellRenderer;
-import com.framsticks.util.Dispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.swing.KeyboardModifier;
 import org.apache.log4j.Logger;
 
 import javax.swing.*;
+import javax.swing.event.TreeModelEvent;
+import javax.swing.event.TreeModelListener;
 import javax.swing.event.TreeSelectionEvent;
 import javax.swing.event.TreeSelectionListener;
 import javax.swing.tree.*;
+
 import java.awt.*;
 import java.awt.datatransfer.StringSelection;
-import java.awt.event.ActionEvent;
-import java.awt.event.MouseAdapter;
-import java.awt.event.MouseEvent;
+import java.awt.event.*;
 import java.util.HashMap;
 import java.util.Map;
@@ -23,265 +25,319 @@
  * @author Piotr Sniegowski
  */
+@SuppressWarnings("serial")
 public class Frame extends JFrame implements Dispatcher {
 
-    private static final Logger LOGGER = Logger.getLogger(Frame.class.getName());
-
-    protected final Browser browser;
-
-    protected final Dimension screenDimension = Toolkit.getDefaultToolkit().getScreenSize();
-
-
-    final protected CardLayout cardPanelLayout = new CardLayout();
-    protected final JPanel cardPanel = new JPanel();
-
-    protected JScrollPane treeScrollPane;
-    protected JTree tree;
-    protected DefaultTreeModel treeModel;
-    protected javax.swing.tree.MutableTreeNode rootNode;
-    //final Instance instance;
-    protected JPanel treePanel;
-    protected  JPopupMenu treePopupMenu;
-    protected JMenuItem treePopupMenuHeader;
-
-    TreeNode currentlyPoppedTreeNode;
-    protected JLabel statusBar;
-    protected JPanel mainPanel;
-    protected JPanel leftPanel;
-    protected JPanel normalWorkPanel;
-    protected CardLayout mainPanelLayout;
-
-    protected final Map<BrowserEndpoint, EndpointAtFrame> endpoints = new HashMap<BrowserEndpoint, EndpointAtFrame>();
-
-    public Frame(String title, Browser browser) {
+	private static final Logger log = Logger.getLogger(Frame.class.getName());
+
+	protected final Browser browser;
+
+	protected final Dimension screenDimension = Toolkit.getDefaultToolkit()
+			.getScreenSize();
+
+	final protected CardLayout cardPanelLayout = new CardLayout();
+	protected final JPanel cardPanel = new JPanel();
+
+	protected JScrollPane treeScrollPane;
+	protected JTree tree;
+	protected DefaultTreeModel treeModel;
+	protected javax.swing.tree.MutableTreeNode rootNode;
+	//final Instance instance;
+	protected JPanel treePanel;
+	protected JPopupMenu treePopupMenu;
+	protected JMenuItem treePopupMenuHeader;
+
+	TreeNode currentlyPoppedTreeNode;
+	protected JLabel statusBar;
+	protected JPanel mainPanel;
+	protected JPanel leftPanel;
+	protected JPanel normalWorkPanel;
+	protected CardLayout mainPanelLayout;
+
+	protected JMenuBar menuBar;
+	protected JMenu fileMenu;
+	protected JMenu editMenu;
+	protected JMenu viewMenu;
+	protected JMenu windowMenu;
+	protected JMenu helpMenu;
+
+	protected final Map<BrowserEndpoint, EndpointAtFrame> endpoints = new HashMap<BrowserEndpoint, EndpointAtFrame>();
+	protected final Map<Instance, EndpointAtFrame> endpointsByInstance = new HashMap<Instance, EndpointAtFrame>();
+
+	public Frame(String title, Browser browser) {
 		super(title);
-        this.browser = browser;
-    }
-
-    public void configure() {
-
-        Container contentPane = this.getContentPane();
-        contentPane.setLayout(new BorderLayout());
-
-        treePopupMenu = new JPopupMenu("title");
-        treePopupMenu.setName("popup");
-        treePopupMenuHeader = new JMenuItem();
-        treePopupMenuHeader.setForeground(Color.BLUE);
-        treePopupMenu.add(treePopupMenuHeader);
-        treePopupMenu.addSeparator();
-        //TODO: add to favourites
-        //TODO: remove from favourites
-        //TODO: open in new window as root
-        //TODO: refresh
-        //TODO: open in console
-
-        treePopupMenu.add(new JMenuItem("Refresh"));
-        treePopupMenu.add(new JMenuItem("Open in new frame as root"));
-		addNodeActionToTreePopupMenu("Copy path to clipboard", new NodeAction() {
-			@Override
-			public void actionPerformed(TreeNode treeNode) {
-				Path path = treeNode.getInstancePath();
-				StringSelection selection = new StringSelection(path.toString());
-				getToolkit().getSystemClipboard().setContents(selection, selection);
-			}
-		});
-        //this.add(createMenuItem("Add to favourites", null));
-        //this.add(createMenuItem("Remove from favourites", null));
-
-        treePanel = new JPanel();
-        treePanel.setLayout(new BorderLayout());
-
-        treeModel = new DefaultTreeModel(null);
-
-        tree = new JTree(treeModel);
-        tree.setRootVisible(false);
-        ToolTipManager.sharedInstance().registerComponent(tree);
-
-        tree.addTreeSelectionListener(new TreeSelectionListener() {
-            @Override
-            public void valueChanged(TreeSelectionEvent e) {
-                chooseTreeNode(e.getNewLeadSelectionPath());
-            }
-        });
-
-        tree.setExpandsSelectedPaths(true);
-        tree.setEditable(false);
-        tree.setDoubleBuffered(true);
-        tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
-        tree.setShowsRootHandles(true);
-        tree.setRowHeight(26);
-        tree.setDoubleBuffered(true);
-        tree.addMouseListener(new MouseAdapter() {
-            @Override
-            public void mousePressed(MouseEvent e) {
-                assert isActive();
-                showPopup(e);
-            }
-
-            @Override
-            public void mouseReleased(MouseEvent e) {
-                assert isActive();
-                showPopup(e);
-            }
-        });
-        tree.setCellRenderer(new TreeCellRenderer());
-
-        treeScrollPane = new JScrollPane(tree);
-        treeScrollPane.setBorder(BorderFactory.createEmptyBorder());
-
-        treePanel.add(treeScrollPane);
-
-        rootNode = new DefaultMutableTreeNode();
-        treeModel.setRoot(rootNode);
-
-        normalWorkPanel = new JPanel();
-        normalWorkPanel.setLayout(new BorderLayout());
-
-        mainPanel = new JPanel();
-        mainPanelLayout = new CardLayout();
-        mainPanel.setLayout(mainPanelLayout);
-        mainPanel.add(normalWorkPanel, "browser");
-
-        contentPane.add(createMenu(), BorderLayout.NORTH);
-        contentPane.add(mainPanel, BorderLayout.CENTER);
-        contentPane.add(statusBar, BorderLayout.SOUTH);
-
-        leftPanel = new JPanel();
-        leftPanel.setLayout(new BorderLayout());
-        JPanel leftTopPanel = createLeftTopPanel();
-        if (leftTopPanel != null) {
-            leftPanel.add(leftTopPanel, BorderLayout.PAGE_START);
-        }
-        leftPanel.add(treePanel, BorderLayout.CENTER);
-        leftPanel.setBackground(Color.WHITE);
-        leftPanel.setForeground(Color.WHITE);
-
-        JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, leftPanel, cardPanel);
-        split.setPreferredSize(new Dimension(this.browser.getConfig().getInteger("size.width", 1000), this.browser.getConfig().getInteger("size.height", 500)));
-        split.setMaximumSize(screenDimension);
-        split.setOneTouchExpandable(true);
-        split.setDividerLocation(250);
-        split.setDividerSize(5);
-
-        normalWorkPanel.add(split);
-
-        //this.setVisible(true);
-        mainPanelLayout.show(mainPanel, "browser");
-
-        cardPanel.setLayout(cardPanelLayout);
+		/** this is done to remove the current value label from above the slider,
+		 * because it cannot put to work properly with floating-point value sliders,
+		 * nor it can be removed in normal way through JSlider methods  */
+		UIManager.put("Slider.paintValue", false);
+		this.browser = browser;
+		log.debug("creating " + this);
+	}
+
+	public void configure() {
+
+		Container contentPane = this.getContentPane();
+		contentPane.setLayout(new BorderLayout());
+
+		treePopupMenu = new JPopupMenu("title");
+		treePopupMenu.setName("popup");
+		treePopupMenuHeader = new JMenuItem();
+		treePopupMenuHeader.setForeground(Color.BLUE);
+		treePopupMenu.add(treePopupMenuHeader);
+		treePopupMenu.addSeparator();
+		//TODO: add to favourites
+		//TODO: remove from favourites
+		//TODO: open in new window as root
+		//TODO: refresh
+		//TODO: open in console
+
+		treePopupMenu.add(new JMenuItem("Refresh"));
+		treePopupMenu.add(new JMenuItem("Open in new frame as root"));
+		addNodeActionToTreePopupMenu("Copy path to clipboard",
+				new NodeAction() {
+					@Override
+					public void actionPerformed(TreeNode treeNode) {
+						Path path = treeNode.getInstancePath();
+						StringSelection selection = new StringSelection(path
+								.toString());
+						getToolkit().getSystemClipboard().setContents(
+								selection, selection);
+					}
+				});
+		//this.add(createMenuItem("Add to favourites", null));
+		//this.add(createMenuItem("Remove from favourites", null));
+
+		treePanel = new JPanel();
+		treePanel.setLayout(new BorderLayout());
+
+		treeModel = new DefaultTreeModel(null);
+		treeModel.addTreeModelListener(new TreeModelListener() {
+
+			@Override
+			public void treeNodesChanged(TreeModelEvent arg0) {
+				log.trace("treeNodesChanged: " + arg0);
+			}
+
+			@Override
+			public void treeNodesInserted(TreeModelEvent arg0) {
+				// log.trace("treeNodesInserted: " + arg0);
+			}
+
+			@Override
+			public void treeNodesRemoved(TreeModelEvent arg0) {
+				log.trace("treeNodesRemoved: " + arg0);
+			}
+
+			@Override
+			public void treeStructureChanged(TreeModelEvent arg0) {
+				log.trace("treeStructureChanged: " + arg0);
+			}
+		});
+
+		tree = new JTree(treeModel);
+		tree.setName("tree");
+		tree.setRootVisible(false);
+		tree.setExpandsSelectedPaths(true);
+		tree.setSelectionModel(new DefaultTreeSelectionModel());
+		ToolTipManager.sharedInstance().registerComponent(tree);
+
+		tree.addTreeSelectionListener(new TreeSelectionListener() {
+			@Override
+			public void valueChanged(TreeSelectionEvent e) {
+				chooseTreeNode(e.getNewLeadSelectionPath());
+			}
+		});
+
+		tree.setExpandsSelectedPaths(true);
+		tree.setEditable(false);
+		tree.setDoubleBuffered(true);
+		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
+		tree.setShowsRootHandles(true);
+		tree.setRowHeight(26);
+		tree.setDoubleBuffered(true);
+		tree.addMouseListener(new MouseAdapter() {
+			@Override
+			public void mousePressed(MouseEvent e) {
+				assert isActive();
+				showPopup(e);
+			}
+
+			@Override
+			public void mouseReleased(MouseEvent e) {
+				assert isActive();
+				showPopup(e);
+			}
+		});
+
+		new KeyboardModifier(tree, JComponent.WHEN_FOCUSED)
+			.join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0))
+			.join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0))
+			.join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0))
+			.join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0))
+			;
+
+		tree.setCellRenderer(new TreeCellRenderer());
+
+		treeScrollPane = new JScrollPane(tree);
+		treeScrollPane.setBorder(BorderFactory.createEmptyBorder());
+
+		treePanel.add(treeScrollPane);
+
+		rootNode = new DefaultMutableTreeNode();
+		rootNode.setUserObject("root");
+		treeModel.setRoot(rootNode);
+
+		normalWorkPanel = new JPanel();
+		normalWorkPanel.setLayout(new BorderLayout());
+		normalWorkPanel.setName("browser");
+
+		mainPanel = new JPanel();
+		mainPanel.setName("main");
+		mainPanelLayout = new CardLayout();
+		mainPanel.setLayout(mainPanelLayout);
+		mainPanel.add(normalWorkPanel, "browser");
+
+		menuBar = new JMenuBar();
+
+		fileMenu = menuBar.add(new JMenu("File"));
+		editMenu = menuBar.add(new JMenu("Edit"));
+		viewMenu = menuBar.add(new JMenu("View"));
+		windowMenu = menuBar.add(new JMenu("Window"));
+		helpMenu = menuBar.add(new JMenu("Help"));
+
+		contentPane.add(menuBar, BorderLayout.NORTH);
+		contentPane.add(mainPanel, BorderLayout.CENTER);
+		contentPane.add(statusBar, BorderLayout.SOUTH);
+
+		leftPanel = new JPanel();
+		leftPanel.setLayout(new BorderLayout());
+		//leftPanel.add(new ViewerTest(), BorderLayout.PAGE_START);
+//        JPanel leftTopPanel = createLeftTopPanel();
+//        if (leftTopPanel != null) {
+//            leftPanel.add(leftTopPanel, BorderLayout.PAGE_START);
+//        }
+		leftPanel.add(treePanel, BorderLayout.CENTER);
+		leftPanel.setBackground(Color.WHITE);
+		leftPanel.setForeground(Color.WHITE);
+
+		cardPanel.setName("card");
+		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, leftPanel, cardPanel);
+		split.setPreferredSize(browser.defaultFrameDimension);
+		split.setMaximumSize(screenDimension);
+		split.setOneTouchExpandable(true);
+		split.setDividerLocation(250);
+		split.setDividerSize(5);
+		split.setName("split");
+
+		normalWorkPanel.add(split);
+
+		//this.setVisible(true);
+		mainPanelLayout.show(mainPanel, "browser");
+
+		cardPanel.setLayout(cardPanelLayout);
 
 		this.pack();
 		tree.requestFocusInWindow();
 
-    }
-
-    protected JMenuBar createMenu() {
-        return new JMenuBar();
-    }
-
-    protected JPanel createLeftTopPanel() {
-        return null;
-    }
-
-    public void repaintTree() {
-        //LOGGER.debug("repainting");
-        //tree.repaint();
-    }
-
-    public EndpointAtFrame getOrCreateEndpointAtFrame(BrowserEndpoint endpoint) {
-        assert isActive();
-        if (endpoints.containsKey(endpoint)) {
-            return endpoints.get(endpoint);
-        }
-        EndpointAtFrame e = new EndpointAtFrame(endpoint, this);
-        endpoints.put(endpoint, e);
-        return e;
-    }
-
-    public void addRootPath(BrowserEndpoint endpoint, Path path) {
-        assert isActive();
-        TreeNode node = new TreeNode(this, getOrCreateEndpointAtFrame(endpoint), path);
-        treeModel.insertNodeInto(node, rootNode, rootNode.getChildCount());
-        tree.expandPath(new TreePath(rootNode));
-    }
-
-    @Override
-    public boolean isActive() {
-        return SwingDispatcher.instance.isActive();
-    }
-
-    @Override
-    public void invokeLater(Runnable runnable) {
-        SwingDispatcher.instance.invokeLater(runnable);
-    }
-
-    public Action addActionToTreePopupMenu(Action action) {
-        assert isActive();
-        treePopupMenu.add(action);
-        return action;
-    }
-
-    public Action addNodeActionToTreePopupMenu(String title, final NodeAction nodeAction) {
-        assert isActive();
-        return addActionToTreePopupMenu(new AbstractAction(title) {
-            @Override
-            public void actionPerformed(ActionEvent e) {
-                TreeNode treeNode = getCurrentlyPoppedTreeNode();
-                if (treeNode == null) {
-                    return;
-                }
-                nodeAction.actionPerformed(treeNode);
-            }
-        });
-    }
-
-
-    public void showPanel(Panel panel) {
-        assert isActive();
-        assert panel != null;
-        cardPanelLayout.show(cardPanel, panel.getFullName());
-    }
-
-    private void showPopup(MouseEvent e) {
-        assert isActive();
-        if (!e.isPopupTrigger()) {
-            return;
-        }
-        currentlyPoppedTreeNode = findTreeNodeByTreePath(tree.getPathForLocation(e.getX(), e.getY()));
-        if (currentlyPoppedTreeNode == null) {
-            return;
-        }
-        treePopupMenu.show(e.getComponent(), e.getX(), e.getY());
-        //currentlyPoppedPanel.getNode().getFramsClass().getName()
-        //treePopupMenuHeader.setText(currentlyPoppedTreeNode.getNode().getPath());
-    }
-
-    public TreeNode getCurrentlyPoppedTreeNode() {
-        assert isActive();
-        return currentlyPoppedTreeNode;
-    }
-
-
-    public void clear() {
-        treeModel.setRoot(null);
-        cardPanel.removeAll();
-        cardPanel.updateUI();
-        tree.setEnabled(false);
-    }
-
-
-    public void markNodeChanged(MutableTreeNode treeNode, TreePath path) {
-        assert isActive();
-        treeModel.nodeStructureChanged(treeNode);
-        tree.setSelectionPath(path);
-        tree.repaint();
-    }
-
-    public TreePath startChange() {
-        return tree.getSelectionPath();
-    }
-
-
-    public void selectTreeNode(final TreeNode treeNode) {
-        assert isActive();
+		log.debug("frame configured");
+
+	}
+
+	protected JPanel createLeftTopPanel() {
+		return null;
+	}
+
+	public void addRootPath(BrowserEndpoint endpoint, Path path) {
+		assert isActive();
+		assert !endpoints.containsKey(endpoint);
+
+		EndpointAtFrame e = new EndpointAtFrame(endpoint, this);
+		endpoint.getInstance().addListener(e);
+		endpoints.put(endpoint, e);
+		endpointsByInstance.put(endpoint.getInstance(), e);
+		TreeNode node = new TreeNode(e, path);
+		e.rootTreeNode = node;
+		treeModel.insertNodeInto(node, rootNode, rootNode.getChildCount());
+		tree.expandPath(new TreePath(rootNode));
+	}
+
+	@Override
+	public boolean isActive() {
+		return SwingDispatcher.instance.isActive();
+	}
+
+	@Override
+	public void invokeLater(Runnable runnable) {
+		SwingDispatcher.instance.invokeLater(runnable);
+	}
+
+	public Action addActionToTreePopupMenu(Action action) {
+		assert isActive();
+		treePopupMenu.add(action);
+		return action;
+	}
+
+	public Action addNodeActionToTreePopupMenu(String title, final NodeAction nodeAction) {
+		assert isActive();
+		return addActionToTreePopupMenu(new AbstractAction(title) {
+			@Override
+			public void actionPerformed(ActionEvent e) {
+				TreeNode treeNode = getCurrentlyPoppedTreeNode();
+				if (treeNode == null) {
+					return;
+				}
+				nodeAction.actionPerformed(treeNode);
+			}
+		});
+	}
+
+	public void showPanel(Panel panel) {
+		assert isActive();
+		assert panel != null;
+		cardPanelLayout.show(cardPanel, panel.getUniqueName());
+	}
+
+
+	private void showPopup(MouseEvent e) {
+		assert isActive();
+		if (!e.isPopupTrigger()) {
+			return;
+		}
+		currentlyPoppedTreeNode = findTreeNodeByTreePath(tree.getPathForLocation(e.getX(), e.getY()));
+		if (currentlyPoppedTreeNode == null) {
+			return;
+		}
+		treePopupMenu.show(e.getComponent(), e.getX(), e.getY());
+		//currentlyPoppedPanel.getNode().getFramsClass().getName()
+		//treePopupMenuHeader.setText(currentlyPoppedTreeNode.getNode().getPath());
+	}
+
+	public TreeNode getCurrentlyPoppedTreeNode() {
+		assert isActive();
+		return currentlyPoppedTreeNode;
+	}
+
+
+	public void clear() {
+		treeModel.setRoot(null);
+		cardPanel.removeAll();
+		cardPanel.updateUI();
+		tree.setEnabled(false);
+	}
+
+	public Runnable startChange(final DefaultMutableTreeNode node) {
+		assert isActive();
+		final TreePath selection = tree.getSelectionPath();
+		return new Runnable() {
+			@Override
+			public void run() {
+				assert isActive();
+				treeModel.nodeChanged(node);
+				tree.setSelectionPath(selection);
+			}
+		};
+	}
+
+	public void selectTreeNode(final TreeNode treeNode) {
+		assert isActive();
 /*		final Panel panel = treeNode.getOrCreatePanel();
 		if (panel == null) {
@@ -291,28 +347,53 @@
 		treeNode.updateData();
 		showPanel(panel);*/
-    }
-
-    public TreeNode findTreeNodeByTreePath(TreePath treePath) {
-        assert isActive();
-        if (treePath == null) {
-            return null;
-        }
-        if (!(treePath.getLastPathComponent() instanceof TreeNode)) {
-            return null;
-        }
-        return (TreeNode)treePath.getLastPathComponent();
-    }
-
-
-
-    public void chooseTreeNode(TreePath treePath) {
-        assert isActive();
-        final TreeNode treeNode = findTreeNodeByTreePath(treePath);
-        if (treeNode == null) {
-            return;
-        }
-        treeNode.select();
-    }
-
+	}
+
+	public TreeNode findTreeNodeByTreePath(TreePath treePath) {
+		assert isActive();
+		if (treePath == null) {
+			return null;
+		}
+		if (!(treePath.getLastPathComponent() instanceof TreeNode)) {
+			return null;
+		}
+		return (TreeNode)treePath.getLastPathComponent();
+	}
+
+	public void chooseTreeNode(TreePath treePath) {
+		assert isActive();
+		final TreeNode treeNode = findTreeNodeByTreePath(treePath);
+		if (treeNode == null) {
+			return;
+		}
+		treeNode.select();
+	}
+
+	public void goTo(Path path) {
+		assert isActive();
+		final TreePath treePath = endpointsByInstance.get(path.getInstance()).getTreePath(path, false);
+		log.info("go to path: " + path + "(" + treePath + ")");
+		invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				tree.setSelectionPath(treePath);
+				tree.makeVisible(treePath);
+				assert tree.isVisible(treePath);
+			}
+
+		});
+	}
+
+
+	public void addNode(TreeNode child, DefaultMutableTreeNode parent) {
+		assert isActive();
+		Runnable r = startChange(parent);
+		treeModel.insertNodeInto(child, parent, parent.getChildCount());
+		r.run();
+	}
+
+	@Override
+	public String toString() {
+		return getTitle() + "@" + browser.getName();
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 84)
@@ -0,0 +1,127 @@
+package com.framsticks.gui;
+
+import java.awt.Dimension;
+import java.util.Collection;
+import java.util.Map;
+
+import javax.swing.Box;
+import javax.swing.BoxLayout;
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.gui.controls.CheckBoxControl;
+import com.framsticks.gui.controls.Control;
+import com.framsticks.gui.controls.EnumControl;
+import com.framsticks.gui.controls.EventControl;
+import com.framsticks.gui.controls.ProcedureControl;
+import com.framsticks.gui.controls.SliderControl;
+import com.framsticks.gui.controls.TextAreaControl;
+import com.framsticks.gui.controls.TextFieldControl;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.Param;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.types.BinaryParam;
+import com.framsticks.params.types.BooleanParam;
+import com.framsticks.params.types.ColorParam;
+import com.framsticks.params.types.DecimalParam;
+import com.framsticks.params.types.EnumParam;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.FloatParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.params.types.StringParam;
+import com.framsticks.params.types.UniversalParam;
+import com.framsticks.util.lang.Strings;
+
+public final class Gui {
+
+	private static final Logger log = Logger.getLogger(Gui.class.getName());
+
+	private Gui() {
+	}
+
+	public static Control createComponentForText(PrimitiveParam valueParam) {
+		if (valueParam.getMin(Object.class) != null) {
+			return new TextAreaControl(valueParam);
+		}
+		return new TextFieldControl(valueParam);
+	}
+
+	public static Control createSuitable(Param param) {
+
+		if (param instanceof EnumParam) {
+			return new EnumControl((EnumParam) param);
+		}
+		if (param instanceof BooleanParam) {
+			return new CheckBoxControl((BooleanParam) param);
+		}
+		if (param instanceof DecimalParam) {
+			DecimalParam decimalParam = (DecimalParam)param;
+			if (decimalParam.getMin(Integer.class) != null && decimalParam.getMax(Integer.class) != null) {
+				return new SliderControl(decimalParam);
+			}
+			return createComponentForText(decimalParam);
+		}
+		if (param instanceof FloatParam) {
+			FloatParam floatParam = (FloatParam)param;
+			if (floatParam.getMin(Double.class) != null && floatParam.getMax(Double.class) != null) {
+				return new SliderControl(floatParam);
+			}
+			return createComponentForText(floatParam);
+		}
+		if (param instanceof StringParam) {
+			return createComponentForText((StringParam)param);
+		}
+		if (param instanceof ProcedureParam) {
+			return new ProcedureControl((ProcedureParam)param);
+		}
+		if (param instanceof BinaryParam) {
+			return createComponentForText((BinaryParam)param);
+		}
+		if (param instanceof ColorParam) {
+			return createComponentForText((ColorParam) param);
+		}
+		if (param instanceof UniversalParam) {
+			return new TextAreaControl((UniversalParam)param);
+		}
+		if (param instanceof EventParam) {
+			return new EventControl((EventParam)param);
+		}
+		return null;
+	}
+
+	public static void fillWithControls(JPanel panel, Collection<Param> params, Map<Param, Control> components) {
+		for (Param param : params) {
+			if (param.isUserHidden()) {
+				continue;
+			}
+			assert !(param instanceof CompositeParam);
+			Control control = Gui.createSuitable(param);
+			if (control == null) {
+				log.error("component for param " + param + " of type " + param.getClass().getSimpleName() + " was not added");
+				continue;
+			}
+			log.debug("add component for " + param);
+			JPanel line = new JPanel();
+			line.setLayout(new BoxLayout(line, BoxLayout.LINE_AXIS));
+			line.setAlignmentX(JPanel.LEFT_ALIGNMENT);
+			JLabel label = new JLabel(Strings.notEmpty(param.getName()) ? param.getName() : "? (" + param.getId() + ")");
+			label.setToolTipText(control.getToolTipText());
+			label.setHorizontalAlignment(JLabel.RIGHT);
+			Dimension labelSize = new Dimension(150, 30);
+			label.setMaximumSize(labelSize);
+			label.setMinimumSize(labelSize);
+			label.setPreferredSize(labelSize);
+			line.add(label);
+			line.add(Box.createRigidArea(new Dimension(8, 0)));
+			line.add(control);
+			line.revalidate();
+			panel.add(line);
+			panel.add(Box.createRigidArea(new Dimension(0, 8)));
+			//component.setAlignmentX(LEFT_ALIGNMENT);
+			components.put(param, control);
+		}
+
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/ImageProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ImageProvider.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/ImageProvider.java	(revision 84)
@@ -7,5 +7,4 @@
 
 import javax.swing.*;
-import java.net.URL;
 import java.util.HashMap;
 import java.util.LinkedHashMap;
@@ -16,5 +15,5 @@
 public class ImageProvider {
 
-    private final static Logger LOGGER = Logger.getLogger(ImageProvider.class.getName());
+    private final static Logger log = Logger.getLogger(ImageProvider.class.getName());
 
 
@@ -87,5 +86,5 @@
             return icon;
 		} catch (Exception ignored) {
-            LOGGER.error("failed to read icon: " + resourceName);
+            log.error("failed to read icon: " + resourceName);
 		}
 		return null;
Index: java/main/src/main/java/com/framsticks/gui/ListPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ListPanel.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/ListPanel.java	(revision 84)
@@ -12,13 +12,13 @@
  */
 @SuppressWarnings("serial")
-public class ListPanel extends Panel {
+public class ListPanel extends ModifiablePanel {
 
-	private static final Logger LOGGER = Logger.getLogger(ListPanel.class.getName());
+	private static final Logger log = Logger.getLogger(ListPanel.class.getName());
 
 	final protected TableModel tableModel = new TableModel();
 	final protected JTable table = new JTable(tableModel);
 
-	public ListPanel(EndpointAtFrame endpoint) {
-		super(endpoint, "list");
+	public ListPanel(Parameters parameters) {
+		super(parameters);
 
 		table.getTableHeader().setReorderingAllowed(false);
@@ -29,8 +29,10 @@
 		contentPanel.add(table);
 
-        /*
+		log.debug("created");
+
+		/*
 		AccessInterface elementAccess = ((ListAccess)access).getElementAccess();
 		if (elementAccess == null) {
-			LOGGER.error("no type class");
+			log.error("no type class");
 			return;
 		}
@@ -50,5 +52,5 @@
 		}
 		tableModel.addRow(list.toArray());
-        */
+		*/
 		/*
 		JMenuBar menuBar = new JMenuBar();
@@ -105,6 +107,11 @@
 
 	@Override
-	public void refreshComponents(AccessInterface access) {
+	public void pullValuesFromLocalToUser(AccessInterface access) {
 
 	}
+
+	@Override
+	public String getTitle() {
+		return "List";
+	}
 }
